<template>
  <tr>
    <modal v-if='displayModal' @close='hideStats' :logs="link.click_logs" />
    <td class="text-left"><a :href="link.url" target="_blank">{{ link.url }}</a></td>
    <td class="text-left"><a :href="link.short_url" target="_blank">{{ link.short_url }}</a></td>
    <td>{{ totalClicks }}</td>
    <td>{{ link.created_at | moment('YYYY-MM-DD') }}</td>
    <td>{{ link.expired_at | moment('YYYY-MM-DD') }}</td>
    <td>
      <select v-model="validity">
        <option v-for="i in validityRange">{{ i }}</option>
      </select>
    </td>
    <td>
      <button class="btn btn-blue" @click="displayStats"><i class="fa fa-fw fa-chart-bar"></i></button>
      <button class="btn btn-yellow" @click="updateLink({ duration: 0 })"><i class="fa fa-fw fa-clock"></i></button>
      <button class="btn btn-red" @click="destroyLink"><i class="fa fa-fw fa-trash"></i></button>
    </td>
  </tr>
</template>

<script>
import modal from '@/components/ShortLinkStatsModal.vue'

export default{
  props: ['link'],
  components: { modal },
  data () {
    return {
      validity: this.link.validity,
      displayModal: false
    }
  },
  computed: {
    validityRange () {
      let limit = this.$store.getters.signedIn ? 30 : 3
      return new Array(limit).fill(1).map((n, i) => n + i)
    },
    totalClicks () {
      let logs = this.link.click_logs

      return Object.keys(logs).reduce( (sum, key) => sum + parseInt(logs[key] || 0), 0)
    }
  },
  watch: {
    validity () {
      this.updateLink({ duration: this.validity })
    }
  },
  methods: {
    displayStats () {
      this.displayModal = true
    },
    hideStats () {
      this.displayModal = false
    },
    updateLink (params) {
      this.$http.patch(`/short_links/${this.link.id}`, { short_link: params })
      .then( (response) => {
        this.$emit('updateLink', response.data.short_link)
      })
    },
    destroyLink () {
      this.$http.delete(`/short_links/${this.link.id}`)
      .then( (response) => {
        this.$emit('removeLink', this.link.id)
      })
    }
  }
}
</script>

<style lang='sass' scoped>
tr
  &:nth-child(even)
    background-color: #f2f2f2
  &:hover
    background-color: #ddd
  td
    border: 1px solid #ddd;
    padding: 8px;
    text-align: center
    .btn .fa
      margin: 0
      line-height: 10px
</style>
